#include "SRAmmoSprite.h"
#include "SRGameObject.h"
#include "SRBoomSprite.h"
#include "SRObjectTypes.h"
#include "SRSoundManager.h"
#include "WindowDefs.h"

//#include <iostream>

SRAmmoSprite::SRAmmoSprite( CIconHandle icon, SRIconSprite *parent ) : SRIconSprite(icon)
{
    char type[5];
    *((int*)type) = Type();
    type[4] = 0;
//    cout << "Object of type " << type << " allocated with address " << this << endl;
    fParent = parent;
    fWidth = 7;
    fHeight = 12;
    fParentType = parent->Type();
}

SRAmmoSprite::~SRAmmoSprite()
{
    DisposeCIcon(fCurrentIcon);
}

void SRAmmoSprite::Think()
{
    // if we hit something, we're through
//    if( SRGameObject::instance()->TestForHit(this) )
//    {
//        Die();
//        return;
//    }

    // if we passed the edge of the screen, we're gone
    if( (fX > kGameWindowWidth) || (fX < 0) || (fY > kGameWindowHeight) || (fY < 0) )
    {
        SRGameObject::instance->Recycle(this);
    }
}

// Something hit us!
bool SRAmmoSprite::Hit( SRObject *other )
{
    bool died = true;

    // What was it that hit us?  Can it kill us?
    switch(other->Type())
    {
        case kPlayerAmmoType:
            if(Type() == kPlayerAmmoType || Type() == kPlayerType)
                died = false;
            break;
        case kEnemyAmmoType:
            if(Type() == kEnemyAmmoType || Type() == kEnemyType)
                died = false;
            else if(Type() == kPlayerAmmoType || Type() == kPlayerType)
                SRGameObject::instance->Scored(kTakedownPoints);
            break;
        case kGenericAmmoType:
            if(Type() == kGenericAmmoType)
                died = false;
            break;
    }
    
    // if it can kill us, it did...
    if(died) Die();
    return died;
}

int SRAmmoSprite::Type()
{
    switch(fParentType)
    {
        case kPlayerType:
            return kPlayerAmmoType;
        case kEnemyType:
            return kEnemyAmmoType;
        default:
            return kGenericAmmoType;
    }
}

void SRAmmoSprite::Die()
{
/*    if(fParent)
    {
        fParent->ChildDied(this);
    }*/
    if(fParentType == kPlayerType)
        SRSoundManager::PlaySoundEffect(SRSoundManager::SFXammoBoom);
        
    new SRBoomSprite(this);
}

// called when the mothership dies...
void SRAmmoSprite::ShipDied()
{
    fParent = 0;
}
